import { firestore } from 'firebase';
import { BaseObject, WithId } from './types';
export declare class Query<T extends BaseObject> {
    private query;
    private converter;
    constructor(query: firestore.Query, converter: (data: BaseObject) => BaseObject);
    get(): Promise<WithId<T>[]>;
    limit(num: number): this;
    limitToLast(num: number): this;
    orderBy(field: string, direction?: firestore.OrderByDirection): this;
    where(field: string, operator: firestore.WhereFilterOp, value: string | number | Date | null): this;
}
