"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Query = void 0;
const helper_1 = require("./helper");
class Query {
    constructor(query, converter) {
        this.query = query;
        this.converter = converter;
    }
    get() {
        return __awaiter(this, void 0, void 0, function* () {
            const snap = yield this.query.get();
            return snap.docs.flatMap((doc) => {
                const data = helper_1.mergeIdFromSnap(doc);
                if (data === undefined)
                    return [];
                return this.converter(data);
            });
        });
    }
    limit(num) {
        this.query = this.query.limit(num);
        return this;
    }
    limitToLast(num) {
        this.query = this.query.limitToLast(num);
        return this;
    }
    orderBy(field, direction) {
        this.query.orderBy(field, direction);
        return this;
    }
    where(field, operator, value) {
        this.query.where(field, operator, value);
        return this;
    }
}
exports.Query = Query;
