"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isObject = exports.convertTimestampToDate = exports.mergeIdFromSnap = void 0;
const app_1 = require("firebase/app");
function mergeIdFromSnap(snap) {
    const data = snap.data();
    if (!data)
        return undefined;
    return Object.assign(Object.assign({}, data), { id: snap.id });
}
exports.mergeIdFromSnap = mergeIdFromSnap;
function convertTimestampToDate(data) {
    return Object.fromEntries(Object.entries(data).map(([key, val]) => {
        if (val instanceof app_1.firestore.Timestamp)
            return [key, val.toDate()];
        else if (Array.isArray(val))
            return [
                key,
                val.map((v) => (v instanceof app_1.firestore.Timestamp ? v.toDate() : isObject(v) ? convertTimestampToDate(v) : v)),
            ];
        else if (isObject(val))
            return [key, convertTimestampToDate(val)];
        else
            return [key, val];
    }));
}
exports.convertTimestampToDate = convertTimestampToDate;
// cf) https://qiita.com/suin/items/e8cf3404161cc90821d8
function isObject(x) {
    if (x === null)
        return false;
    else if (typeof x === 'object')
        return true;
    else
        return false;
}
exports.isObject = isObject;
